/**
 * Observer is the implementation of the Observer design pattern
 * @author Rosalva Gallardo
 * @version 1.0.1
 */
import java.util.Observable;
import java.util.Observer;


public class ObserverLL implements Observer{
    private GUIEnvironment lunarLanderEnvironment;
    private Clock lunarLanderClock;
    private SpaceCraft spaceCraft;
    private Processor processor = new Processor();
    public ObserverLL( GUIEnvironment lunarLanderEnvironment,  Clock lunarLanderClock, SpaceCraft spaceCraft) {
          this.lunarLanderEnvironment = lunarLanderEnvironment;               
          lunarLanderEnvironment.addObserver( (Observer) this );
          this.lunarLanderClock = lunarLanderClock;               
          lunarLanderClock.addObserver( (Observer) this );
          this.spaceCraft = spaceCraft;
    }
	/** 
     * Update the subject
     * @param o subject interface
     */  
	public void update(ISubject o) {
		// TODO Auto-generated method stub
		//System.out.println( "Se recibio notificacion." );
		
	}
	/** 
     * Update the lunar lander environment
     * @param o observer
     * @param arg object that contains information to choose the type of update (refresh or calculate)
     */  	
	public void update(Observable o, Object arg) {
		// TODO Auto-generated method stub
		//System.out.println("Se recibio notificacion." + arg.toString());

		if (arg.toString().contains("Clock"))
		{
			processor.refresh(spaceCraft, lunarLanderEnvironment);
		} 
		else
		{
			processor.calculate(spaceCraft, lunarLanderEnvironment);
		}
	}

	/** 
     * Stop the lunar lander environment
     */  	
	public void stop( ) {          
        lunarLanderEnvironment.removeObserver( (Observer) this );            
        lunarLanderClock.removeObserver( (Observer) this );
     
  }
}
